<?php

namespace Drupal\tellstick\Form;

use Drupal\Core\Entity\ContentEntityForm;
use Drupal\Core\Form\FormStateInterface;

/**
 * Form controller for Tellstick edit forms.
 *
 * @ingroup tellstick
 */
class TellstickDataItemForm extends ContentEntityForm {

  /**
   * {@inheritdoc}
   */
  public function buildForm(array $form, FormStateInterface $form_state) {
    /* @var $entity \Drupal\tellstick\Entity\TellstickData */
    $form = parent::buildForm($form, $form_state);

    return $form;
  }

  /**
   * {@inheritdoc}
   */
  public function save(array $form, FormStateInterface $form_state) {
    $entity = &$this->entity;

    $status = parent::save($form, $form_state);

    switch ($status) {
      case SAVED_NEW:
        $this->messenger()
          ->addMessage($this->t('Created the %label Tellstick Data.', [
            '%label' => $entity->id(),
          ]));
        break;

      default:
        $this->messenger()
          ->addMessage($this->t('Saved the %label Tellstick Data.', [
            '%label' => $entity->id(),
          ]));
    }
    $form_state->setRedirect('entity.tellstick_data.canonical', ['tellstick_data' => $entity->id()]);
  }

  /**
   * {@inheritdoc}
   */
  public function validateForm(array &$form, FormStateInterface $form_state) {
    parent::validateForm($form, $form_state);
  }

}
