<?php

namespace Drupal\tellstick\Form;

use Drupal\Core\Entity\ContentEntityConfirmFormBase;
use Drupal\Core\Form\FormStateInterface;
use Drupal\Core\Url;

/**
 * Provides a form for deleting Tellstick Sensor entities.
 *
 * @ingroup tellstick
 */
class TellstickSensorDeleteForm extends ContentEntityConfirmFormBase {

  /**
   * {@inheritdoc}
   */
  public function getQuestion() {
    return $this->t('Are you sure you want to delete sensor %sensor?', ['%sensor' => $this->entity->getSensor()]);
  }

  /**
   * {@inheritdoc}
   */
  public function getCancelUrl() {
    return new Url('entity.tellstick_sensor.collection');
  }

  /**
   * {@inheritdoc}
   */
  public function getConfirmText() {
    return $this->t('Delete');
  }

  /**
   * {@inheritdoc}
   */
  public function submitForm(array &$form, FormStateInterface $form_state) {

    $this->entity->delete();

    $this->messenger()->addMessage(
      $this->t('Sensor @label deleted.',
        [
          '@label' => $this->entity->getSensor(),
        ]
        )
      );

    $form_state->setRedirectUrl($this->getCancelUrl());
    parent::submitForm($form, $form_state);
  }

}
