<?php

namespace Drupal\tellstick\Plugin\views\filter;

use Drupal\views\Plugin\views\filter\InOperator;

/**
 * A filter that ifilters the sensor data.
 *
 * @ingroup views_filter_handlers
 *
 * @ViewsFilter("fdata")
 */
class TellstickHandlerFilterData extends InOperator {

  /**
   * {@inheritdoc}
   */
  public function getValueOptions() {

    if (isset($this->valueOptions)) {
      return $this->valueOptions;
    }

    $this->valueOptions = [];

    $this->valueTitle = $this->t('Sensor type');

    $this->valueOptions['temp'] = $this->t('Temperature');
    $this->valueOptions['wavg'] = $this->t('Wind: Average');
    $this->valueOptions['wgust'] = $this->t('Wind: Gust');
    $this->valueOptions['wdir'] = $this->t('Wind: Direction');
    $this->valueOptions['rrate'] = $this->t('Rain: Rate');
    $this->valueOptions['rtot'] = $this->t('Rain: Total');
    $this->valueOptions['battery'] = $this->t('Battery: Voltage');

    return $this->valueOptions;
  }

  /**
   * {@inheritdoc}
   */
  public function query($group_by = FALSE) {
    $this
      ->ensureMyTable();
    $placeholder = $this
      ->placeholder() . '[]';
    $args = array_values($this->value);
    // dpm($this->placeholder());
    $this->query
      ->addWhereExpression($this->options['group'],
        " {$this->tableAlias}.sensor LIKE {$placeholder}",
      [
        $placeholder => $args,
      ], $args);
  }

}
