<?php

namespace Drupal\tellstick\Plugin\views\filter;

use Drupal\views\Plugin\views\filter\InOperator;

/**
 * A filter that filters the sensor data.
 *
 * @ingroup views_filter_handlers
 *
 * @ViewsFilter("sfilter")
 */
class TellstickHandlerFilterSensor extends InOperator {

  /**
   * {@inheritdoc}
   */
  public function getValueOptions() {

    if (isset($this->valueOptions)) {
      return $this->valueOptions;
    }

    $this->valueOptions = [];

    $this->valueTitle = $this->t('Sensors');

    $tellstickService = \Drupal::service('tellstick.live');
    $result = $tellstickService->getTellstickLiveData();
    foreach ($result->children() as $sensor) {
      $attributes = $sensor->attributes();
      $this->valueOptions[(string) $attributes['name']] = (string) $attributes['name'];
    }
    asort($this->valueOptions);

    return $this->valueOptions;
  }

}
